#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_sby_inhibit.pl
# !*-------------------------------------------------------------------------

$P = "dbamon_sby_inhibit.pl";
use DBI;
require "cgi_handlers.pl";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$fs = "<font size=2>";
#$fe = "</font>";

chop($hostname = `hostname`);

$data_source = "dbi:mysql";
$database = "dbamon";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

$dbms = "mysql";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  ##print "</center><br><font size=2>$date ${P} | <b>$msgmsg</b></font><center>\n";
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
  local($errorMsg) = @_;

  #print "Content-type: text/html\n\n";
  print "<head><title> Database Function Error - Output</title></head>";
  print "<body>";

  print "<h3> The following database error occured - $date<hr></h3>";
  print "</hr noshade>";
  print "<h4> $errorMsg $DBI::errstr</h4>";
  print "SQL statement: <pre>$statement</pre>";

  &PrintLinks;

  print "</body>";
  print "</html>";

  $emsg = $_[0];
  $sqlerror = $DBI::errstr;
  print "==========================================\n";
  print "Fatal Error: $emsg - $sqlerror\n";
  print "==========================================\n";
  chop($admin_email = `grep Admin_EMail: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
  system("echo \"$P - DBAmon Master Server: $hostname\" | mailx -s \"DBAmon Fatal Error: $P - $emsg - $sqlerror\" $admin_email");

  exit(1);
}

#-----------------------------------------------------------------------------
sub error_check
#-----------------------------------------------------------------------------
{
  if ($rqpairs{'reason'} eq "")
  {
     push (@error_list, "Reason must not be blank\n");
  }

  if ($rqpairs{'user'} eq "")
  {
     push (@error_list, "Your initials must not be blank\n");
  }

  ##print "user=$rqpairs{'user'} \n";
  if (length($rqpairs{'user'}) < 2)
  {
     push (@error_list, "Your initials must be 2 characters in length\n");
  }

  $sts = $rqpairs{'s_yyyy'} . $rqpairs{'s_mm'} .$rqpairs{'s_dd'} .$rqpairs{'s_hh'} .$rqpairs{'s_min'} . "00";
  $ets = $rqpairs{'e_yyyy'} . $rqpairs{'e_mm'} .$rqpairs{'e_dd'} .$rqpairs{'e_hh'} .$rqpairs{'e_min'} . "00";
  if ($sts eq "00" || $ets eq "00")
  {
     push (@error_list, "Both timestamp values must not be blank\n");
  }
  if (length($sts) != 14 || length($ets) != 14)
  {
     push (@error_list, "Timestamp values must be filled in completely\n");
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  local($Signal) = @_;
  ##close(you_fill_in_the_file_descriptor);
  ##unlink($you_fill_in_the_tmp_file_name);
  &msg("Signal=$Signal received");
  exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str4="<h3>Insufficient or Missing Information:<hr></h3>";
   $html_str=$str.$str1.$str1.$str4;
   print "$html_str\n";
   print "<h4>Please correct the following:</h4>";
   print "<p>\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}

#-----------------------------------------------------------------------------
sub create_form 
#-----------------------------------------------------------------------------
{
  ##print "<h3>Instance: <font color=blue> $instance </font><hr></h3>\n";
  print "<FORM method='POST' action='/cgi-bin/dbamon_sby_inhibit.pl'>";
  print "<p> <FORM> 
  <TABLE>

  <tr>
  <Td ALIGN=RIGHT><B>$fs Inhibit Period Start Time:<BR></b>
  </B><FONT SIZE=1>(Format: YYYY/MM/DD-HH:MM)
  <TD>
  <INPUT type=text size=4 maxlength=4 name=s_yyyy value=$s_yyyy> /
  <INPUT type=text size=2 maxlength=2 name=s_mm   value=$s_mm>/
  <INPUT type=text size=2 maxlength=2 name=s_dd   value=$s_dd> -
  <INPUT type=text size=2 maxlength=2 name=s_hh   value=$s_hh>:
  <INPUT type=text size=2 maxlength=2 name=s_min  value=$s_min> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Inhibit Period End Time:<BR>
  </B><FONT SIZE=1>(Format: YYYY/MM/DD-HH:MM)
  <TD>
  <INPUT type=text size=4 maxlength=4 name=e_yyyy value=$e_yyyy> /
  <INPUT type=text size=2 maxlength=2 name=e_mm   value=$e_mm>/
  <INPUT type=text size=2 maxlength=2 name=e_dd   value=$e_dd> -
  <INPUT type=text size=2 maxlength=2 name=e_hh   value=$e_hh>:
  <INPUT type=text size=2 maxlength=2 name=e_min  value=$e_min> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Your Initials:<BR>
  </B><FONT SIZE=1>(Your Initials - Example: ab)
  <TD>
  <INPUT type=text size=2 maxlength=2 name=user value=\"$user\"> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Reason For Inhibit:<BR>
  </B><FONT SIZE=1>(Format: Text)</FONT></TH>
  <TD>
  <INPUT type=text size=60 maxlength=60 name=reason value=\"$reason\"> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Action:</b><BR><FONT SIZE=1>(Click One)
  <TD>    <INPUT name=opcode type=radio value=insert CHECKED><b>$fs Insert This Data</b>
      <br><INPUT name=opcode type=radio value=delete        ><b>$fs Delete Any Backup Inhibit Data For This Instance</b>
  \n";

  print "</table> </b> <HR> <center>
  <b><INPUT type=submit value=\"Save Changes\"></input></b>
  <hr>
  <INPUT TYPE=HIDDEN NAME=instance value=\"$instance\">
  </CENTER></form>
  <!--#include virtual=\"/solutions/dba/misc/foot.html\"-->
  ";
}

#-----------------------------------------------------------------------------
sub connectDB
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#----------------------------------------------------------
sub checkDBAmonDBC
#----------------------------------------------------------
{
  my $dbc_server   = $_[0];
  my $dbc_instance = $_[1];

  my $dbc_server_first = (split(/\./,$dbc_server)) [0];

  &msg("    Looking for DBAmon DBC file for $dbc_server_first/$dbc_instance (dbc_server=$dbc_server)");

  $sql = "select
    dbc_filename 
  from 
    dbamon.dbc 
  where 
    dbc_parm = 'Host:' 
    and dbc_value like '${dbc_server_first}%'";
  ##print "sql=$sql\n";

  $sth = $dbh->prepare($sql) || &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  while (@Data = $sth->fetchrow_array)
  {
    $dbc_file   = $Data[0];
  }
  ##print "dbc_file=$dbc_file\n";

  $sql = "select distinct
    dbc_parm,
    dbc_value
  from 
    dbamon.dbc 
  where 
    dbc_filename = '$dbc_file' 
    and dbc_dbamonmode = 'prod' ";
  ##print "sql=$sql\n";

  $sth = $dbh->prepare($sql) || &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  while (@Data = $sth->fetchrow_array)
  {
    $dbc_parm   = $Data[0];
    $dbc_value  = $Data[1];

    $dbc_parm =~ s/://g;

    ##print "dbc_parm=$dbc_parm dbc_value=$dbc_value\n";

    if ($dbc_parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$dbc_${dbc_parm} .= \"$dbc_value \"";
    }
    else
    {
      $cmd = "\$dbc_${dbc_parm} = \"$dbc_value\"";
    }
    ##print "cmd=$cmd \n";
    eval("$cmd");
  }
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement
  if ($dbms eq "oracle")
  {
    $statement  = "select 
      to_char(ts,'YYYYMMDDHH24MISS'),
      instance, 
      to_char(sts,'YYYYMMDDHH24MISS'),
      to_char(ets,'YYYYMMDDHH24MISS'),
      reason, 
      zuser 
      from sby_inhibit where instance = '$instance'";
  }
  else
  {
    $statement  = "select ts, instance, sts, ets, reason, user from sby_inhibit where instance = \"$instance\"";
  }
  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');
 
  $user = "";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts     = $Data[0];
    $sts    = $Data[2];
    $ets    = $Data[3];
    $reason = $Data[4];
    $user   = $Data[5];
    $selectcount++;
  }

  #print "select: $ts $sts $ets $reason\n";

  $s_yyyy = substr($sts,0,4);
  $s_mm   = substr($sts,4,2);
  $s_dd   = substr($sts,6,2);
  $s_hh   = substr($sts,8,2);
  $s_min  = substr($sts,10,2);

  $e_yyyy = substr($ets,0,4);
  $e_mm   = substr($ets,4,2);
  $e_dd   = substr($ets,6,2);
  $e_hh   = substr($ets,8,2);
  $e_min  = substr($ets,10,2);

  $reason =~ s/"/'/g;
  ##$previous_values = "Starttime=$sts Endtime=$ets Reason=$reason User=$user Created=$ts";
  print "<p></b>Previous values for this instance:
  <table border=1 bgcolor=lightblue>
  <tr bgcolor=slate>
    <th><font size=2>Inhibit Start
    <th><font size=2>Inhibit End
    <th><font size=2>Reason
    <th><font size=2>User
    <th><font size=2>Created
  <tr>
    <td><font size=2>$sts
    <td><font size=2>$ets
    <td><font size=2>$reason
    <td><font size=2>$user
    <td><font size=2>$ts
  </table><p><hr>";
}


#-----------------------------------------------------------------------------
sub init_values 
#-----------------------------------------------------------------------------
{
  chop($dateraw = `date +%Y%m%d%H%M%S`);

  $yyyy = substr($dateraw,0,4);
  $mm   = substr($dateraw,4,2);
  $dd   = substr($dateraw,6,2);
  $hour = substr($dateraw,8,2);
  $min  = substr($dateraw,10,2);

  $s_yyyy = $yyyy;
  $s_mm   = $mm;
  $s_dd   = $dd;
  $s_hh   = $hour;
  $s_min  = $min;

  $e_yyyy = $yyyy;
  $e_mm   = $mm;
  $e_dd   = $dd;
  $e_hh   = 23;
  $e_min  = 59;

  $reason = "";
  $user   = "";
}


#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#
# Attempt to make sure that no meta characters are entered in the form.
#
#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub deleteData
#-----------------------------------------------------------------------------
{
  $statement  = "delete from sby_inhibit where instance = '$instance'";

  #print "statement=$statement\n";
  #system("id");

  $rc = $dbh->do($statement) || &displayError('Failed_on_DB_do_delete');

  ##print "<h3>Instance: <font color=blue> $instance </font><hr></h3>\n";
  &msg("All data deleted for this instance");

  &scpDelete if $dbc_Comm_Method eq "ssh" && $dbc_DBMS eq "Oracle";
}

#-----------------------------------------------------------------------------
sub insertData
#-----------------------------------------------------------------------------
{
  $reason   = $rqpairs{'reason'};
  $user     = $rqpairs{'user'};
  $instance = $rqpairs{'instance'};
  #print "reason=$reason instance=$instance\n";

  # Remove naughty characters
  $reason   =~ s/'/"/g;
  $instance =~ s/'/"/g;

  if ($dbms eq "oracle")
  {
    $statement  = "insert into sby_inhibit (instance,reason,zuser,sts,ets) values ";
    $statement .= "(\'$instance\', \'$reason\',\'$user\',
      to_date('$sts', 'YYYYMMDDHH24MISS'),
      to_date('$ets', 'YYYYMMDDHH24MISS')
      )";
  }
  else
  {
    $statement  = "insert into sby_inhibit (instance,reason,user,sts,ets) values ";
    $statement .= "(\'$instance\', \'$reason\',\'$user\',$sts,$ets);";
  }

  #print "statement=$statement\n";
  #system("id");

  #print "test2a\n";
  $rc = $dbh->do($statement) || &displayError('Failed_on_DB_do_insert');
  #print "test2b rc=$rc\n";

  &msg("The following data has been inserted:<ul>");
  print "<li>Instance: <b> $instance</b>\n";
  print "<li>Reason:  <b>$reason</b>\n";
  print "<li>User:   <b>$user</b>\n";
  print "<li>Start Timestamp:  <b>$sts</b>\n";
  print "<li>End Timestamp:  <b>$ets</b>\n";
  print "</ul>\n";
}

#----------------------------------------------------------
sub checkBA
#----------------------------------------------------------
{
  print "$P | Checking DBAMON.BA_INHIBIT for backup age checking inhibit now\n";
  $bai_statement  = "select 
    to_char(sts,\'YYYY/MM/DD-HH24:MI:SS\'), 
    to_char(ets,\'YYYY/MM/DD-HH24:MI:SS\'), 
    to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\'), 
    zuser, 
    reason 
  from sby_inhibit 
  where 
    instance = '$in_hostname:$in_instance'
    and sysdate >= sts and sysdate <= ets";

  ##print "bai_statement=$bai_statement\n";

  $sth = $dbh->prepare($bai_statement) ||
          &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  $bai_selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $bai_sts    = $Data[0];
    $bai_ets    = $Data[1];
    $bai_ts     = $Data[2];
    $bai_user   = $Data[3];
    $bai_reason = $Data[4];
    $bai_selectcount++;
  }

  $bai_user =~ s/ //g;
  print "$P | bai_selectcount=$bai_selectcount\n";  

  if ($bai_selectcount > 0)
  {
    print "$P | BA_INHIBITED\n";
    print "$P | bai_sts=$bai_sts bai_ets=$bai_ets bai_ts=$bai_ts bai_user=$bai_user\n";  
    print "$P | bai_reason=$bai_reason\n";  
  }
}

#----------------------------------------------------------
sub scpDelete
#----------------------------------------------------------
{
  &msg("Deleting Backup Inhibit settings from $in_hostname");
  $cmd = "remsh $hostname -l dbamon 'ssh -l $dbc_Userid $in_hostname rm /tmp/dbamon_sby_inhibit_$in_instance.txt'";
  &msg("Running cmd=$cmd");
  $rc = system("$cmd 2>&1");
  if ($rc != 0)
  {
    &error("Error rc=$rc ssh-ing - cmd=$cmd"); 
  }
}

#----------------------------------------------------------
sub scpFile
#----------------------------------------------------------
{
  &msg("scp-ing Backup Inhibit settings to $in_hostname");
  $tmpfile = "/tmp/dbamon_sby_inhibit_$$.txt";
  open(TMP, ">$tmpfile");
  print TMP "$sts $ets $user $reason\n";
  close(TMP);

  ##print "<pre>";
  ##system("cat $tmpfile");
  ##print "</pre>";

  $cmd = "remsh $hostname -l dbamon 'scp $tmpfile $dbc_Userid\@$in_hostname:/tmp/dbamon_sby_inhibit_$in_instance.txt'";
  &msg("Running cmd=$cmd");
  $rc = system("$cmd 2>&1");
  if ($rc != 0)
  {
    &error("Error rc=$rc scp-ing - cmd=$cmd"); 
  }
  system("rm $tmpfile >/dev/null 2>&1");
}

#----------------------------------------------------------
sub checkSbyInhibit
#----------------------------------------------------------
{
  chop($nowdate = `date +%Y/%m/%d`);
  chop($nowhour = `date +%H`);
  chop($nowday  = `date +%a`);

  $inhibdir  = "/opt/dbamon/adm";
  $inhibfile = "sby_inhibit.txt";

  #
  # Check SERVER-INSTANCE inhibit file
  #

  print "$P | nowdate=$nowdate nowhour=$nowhour nowday=$nowday\n";
  print "$P | Checking $inhibdir/$inhibfile for outage now\n";

  if (-e "$inhibdir/$inhibfile")
  {
    if (system("cat $inhibdir/$inhibfile | grep -v '^#' | grep '\\[$nowdate\\]' 2>&1") == 0)
    {
      print "$P | SBY_INHIBITED (Date)\n";
      return;
    }
    if (system("cat $inhibdir/$inhibfile | grep -v '^#' | grep '\\[$nowdate-$nowhour\\]' 2>&1") == 0)
    {
      print "$P | SBY_INHIBITED (Date-Hour)\n";
      return;
    }
  }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

$| = 1;

##system("echo '' | mailx -s 'monitor--dbamon_sby_inhibit $id [AUTO]' bill_border\@thecompany.com");

#
# Connect to DB
#
&connectDB;

#---- See if this was invoked remotely  
if ($ARGV[0] =~ /^Check:\//)
{
  print "Content-type: text/html\n\n";

  #---- Parse arguments
  $in_verb     = (split('\/',$ARGV[0])) [0];
  $in_hostname = (split('\/',$ARGV[0])) [1];
  $in_instance = (split('\/',$ARGV[0])) [2];
  $in_fqhost   = (split('\/',$ARGV[0])) [3];
  
  print "$P | Starting - in_verb=$in_verb in_hostname=$in_hostname in_instance=$in_instance in_fqhost=$in_fqhost\n"; 

  if ($in_fqhost !~ /lvld/)
  {
    &msg("$P only works for servers in Loveland"); 
    exit 0; 
  }

  if ($in_verb eq "Check:")
  {
    &checkSbyInhibit; 
  }

  print "$P | Done\n"; 
  exit;
}

exit;
